var SESSION_STATUS = Flashphoner.constants.SESSION_STATUS;
var STREAM_STATUS = Flashphoner.constants.STREAM_STATUS;
var localVideo;
var previewStream = null;
var testStarted;
var audioContextForTest;

$(document).ready(function () {
    init_page();
});

function init_page() {
    //$("#url").val(setURL());
    //init api
    try {
        Flashphoner.init({flashMediaProviderSwfLocation: base_url+'web/js/flashphoner/media-provider.swf'});
    } catch(e) {
        console.log("Your browser doesn't support Flash or WebRTC technology necessary for work of an example");
        return;
    }
    Flashphoner.getMediaDevices(null, true).then(function (list) {
        list.audio.forEach(function (device) {
            var audio = document.getElementById("audioInput");
            var i;
            var deviceInList = false;
            for (i = 0; i < audio.options.length; i++) {
                if (audio.options[i].value == device.id) {
                    deviceInList = true;
                    break;
                }
            }
            if (!deviceInList) {
                var option = document.createElement("option");
                option.text = device.label || device.id;
                option.value = device.id;
                audio.appendChild(option);
                option = null;
            }
        });
        list.video.forEach(function (device) {
            console.log(device);
            var video = document.getElementById("videoInput");
            var i;
            var deviceInList = false;
            for (i = 0; i < video.options.length; i++) {
                if (video.options[i].value == device.id) {
                    deviceInList = true;
                    break;
                }
            }
            if (!deviceInList) {
                var option = document.createElement("option");
                option.text = device.label || device.id;
                option.value = device.id;
                video.appendChild(option);
                option = null;
            }
        });
    }).catch(function (error) {
        console.log("Failed to get media devices");
    });
    //local displays
    localVideo = document.getElementById("localVideo");

    onStopped();

    setTimeout(function(){
        //startTest();
    },2000);
    
    return false;
    //set initial button callback
}

function startTest()
{
    Flashphoner.getMediaAccess(getConstaints(), localVideo);
}


function stopTest(need_to_start_again)
{
    return true;
    releaseResourcesForTesting();
    if (Flashphoner.releaseLocalMedia(localVideo))
    {
        if (need_to_start_again > 0)
        {
            startTest();
        }
    }
}

function releaseResourcesForTesting() {
    testStarted = false;
    
    if (audioContextForTest) {
        audioContextForTest.close();
        audioContextForTest = null;
    }
}

function getConstaints() {
    
    if (videoSettings == '')
    {
        videoSettings = '1280x720';
    }
    videoSettings = videoSettings.split('x');
    
    videoSettings[0] = parseInt(videoSettings[0]);
    videoSettings[1] = parseInt(videoSettings[1]);

    var video_width = 1280;
    var video_height = 720;

    if (videoSettings[0] == 1280)
    {
        video_width = 1280;
        video_height = 720;
    }
    else
    if (videoSettings[0] == 720)
    {
        video_width = 720;
        video_height = 720;
    }
    else
    if (videoSettings[0] == 640)
    {
        video_width = 720;
        video_height = 480;
    }
    videoSettings = videoSettings[0]+"x"+videoSettings[1];


    var constraints = {
        audio: true,
        video: true
    };
    if (constraints.audio) {
        constraints.audio = {
            deviceId: $('#audioInput').val()
        };
        constraints.audio.bitrate = 1048576 // 128Kbps
    }
    if (constraints.video) {
        constraints.video = {
            deviceId: $('#videoInput').val(),
            width: video_width,
            height: video_height
        };
        constraints.video.bitrate = (((8*1024)*1024)*2.0), // 2.0Mbps
        constraints.video.frameRate = 30;
    }
    video_width = null;
    video_height = null;
    return constraints;
}

function onStarted(previewStream) {
    $("#publishBtn").text("Stop").off('click').click(function(){
        $(this).prop('disabled', true);
        previewStream.stop();
        previewStream = null;
        Example1.Timer.stop();
        Example2.Timer.stop();
        // Stream is stopped call ajax and enable stop live video on facebook
        //$("#loading_text_div").html("Stopping your live video please wait a second...");
        $("#loading_div_cont").fadeIn("slow");
        var url = base_url+"home/"+fb_live_video_id+"/"+accessToken;
        
        var temp = '';
        $.ajax({
            type: 'POST',
            data: {rand_no:Math.random()},
            url: url,
            cache: false,
            dataType: 'json',
            success: function(data)
            {
                if (data.status = 0)
                {
                    alert(data.msg);
                    $("#loading_div_cont").fadeOut("slow");
                    return false;
                }
                else
                {
                    //alert("Your live video has stopped Now!");
                    //$("#loading_div_cont").fadeOut("slow");
                    window.location.replace(base_url+"home/completedVideos/");
                }
                
            }
        });


    }).prop('disabled', false);
}

function onStopped() {
    $("#publishBtn").text("GO LIVE").off('click').click(function(){
        // Start and push stream to facebook using webcall server
        
        $("#loading_div_cont").fadeIn("slow");

        var url = base_url+"home/"+fbId+"/"+video_id+"/"+accountId+"/"+accessToken;
            
        var e_message = '';
        $.ajax({
            type: 'POST',
            data: {rand_no:Math.random()},
            url: url,
            cache: false,
            dataType: 'json',
            success: function(data)
            {
                if (data.redirect_url != '')
                {
                    window.location.replace(data.redirect_url);
                    return false;
                }
                else
                if (data.error_message != '')
                {
                    e_message = '<ul class="error_messages"><li>'+data.error_message+'</li></ul>';
                    $('.ajax_errors').html(e_message);
                    $("#loading_div_cont").fadeOut("slow");
                    return false;
                }
                else
                if (data.fb_stream_name != '' && data.fb_live_video_id > 0 && data.fb_video_history_id > 0)
                {
                    fb_stream_name = data.fb_stream_name;
                    fb_live_video_id = data.fb_live_video_id;
                    //$("#loading_div_cont").fadeOut("slow");
                    setTimeout(function(){
                        //stopTest(0);
                        start();
                    },7000);
                }
                else
                {
                    e_message = '<ul class="error_messages"><li>Error: Error in publishing live stream, Please try later.</li></ul>';
                    $('.ajax_errors').html(e_message);
                    $("#loading_div_cont").fadeOut("slow");
                    return false;
                }
                
            }
        });
        //$("#loading_div_cont").fadeOut("slow");

        return false;

        //$("#audioInput").prop('disabled', true);
        //$("#videoInput").prop('disabled', true);
        //$("#videoSettings").prop('disabled', true);
    }).prop('disabled', false);
}

function start() {
    $("#loading_div_cont").fadeIn("slow");
    var url = 'wss://webc.yourdomain.com:8443';
    //check if we already have session
    if (Flashphoner.getSessions().length > 0) {
        var session = Flashphoner.getSessions()[0];
        if (session.getServerUrl() == url) {
            startStreaming(session);
            return;
        } else {
            //remove session DISCONNECTED and FAILED callbacks
            session.on(SESSION_STATUS.DISCONNECTED, function () {
            });
            session.on(SESSION_STATUS.FAILED, function () {
            });
            session.disconnect();
        }
    }
    else
    {
        //create session
        console.log("Create new session with url " + url);
        Flashphoner.createSession({urlServer: url}).on(SESSION_STATUS.ESTABLISHED, function(session){
        //session connected, start streaming
        startStreaming(session);
        }).on(SESSION_STATUS.DISCONNECTED, function(){
            setStatus(SESSION_STATUS.DISCONNECTED);
            onStopped();
        }).on(SESSION_STATUS.FAILED, function(){
            setStatus(SESSION_STATUS.FAILED);
            onStopped();
        });
    }
}

function startStreaming(session)
{
    
    $('.shuffle').attr("href", "javascript:;");
    $('#offline_video_mode').attr("href", "javascript:;");
    $("#loading_div_cont").fadeOut("slow");
    session.createStream({
        name: fb_stream_name,
        display: localVideo,
        cacheLocalResources: true,
        receiveVideo: false,
        receiveAudio: false,
        flashShowFullScreenButton: true,
        constraints: getConstaints(),
        rtmpUrl: fb_rtmp_url
    }).on(STREAM_STATUS.PUBLISHING, function(publishStream){

        setStatus(STREAM_STATUS.PUBLISHING);
        onStarted(publishStream);
        Example1.Timer.toggle();
        Example2.Timer.toggle();
        setTimeout(function(){
            is_safe_to_leave = true;
            $("#publishBtn").click();
        },14403000);// Stop after 240 minutes and 3 seconds (14403000), 3 seconds for start delay
    }).on(STREAM_STATUS.UNPUBLISHED, function(){
        setStatus(STREAM_STATUS.UNPUBLISHED);
        //enable start button
        onStopped();
        Example1.Timer.stop();
        Example2.Timer.stop();
    }).on(STREAM_STATUS.FAILED, function(){
        setStatus(STREAM_STATUS.FAILED);
        //enable start button
        onStopped();
        Example1.Timer.stop();
        Example2.Timer.stop();
    }).publish();
    constraints = null;
    

    
    session = null;

}

function changeVideoSettings(val)
{
    videoSettings = val;
    if (val == '1280x720')
    {
        $("#square_video_settings").removeClass('active');
        //$("#meme_video_settings").removeClass('active');
        $("#hd_video_settings").addClass('active');
    }
    else
    if (val == '720x720')
    {
        $("#hd_video_settings").removeClass('active');
        //$("#meme_video_settings").removeClass('active');
        $("#square_video_settings").addClass('active');
    }
    else
    if (val == '640x360')
    {
        $("#hd_video_settings").removeClass('active');
        $("#square_video_settings").removeClass('active');
        $("#meme_video_settings").addClass('active');
    }
    //stopTest(1);
}

//show connection or local stream status
function setStatus(status)
{
    console.log('Status change detected = '+status);

    // var statusField = $("#status");
    // statusField.text(status).removeClass();
    // if (status == "PUBLISHING") {
    //     statusField.attr("class","text-success");
    // } else if (status == "DISCONNECTED" || status == "UNPUBLISHED") {
    //     statusField.attr("class","text-muted");
    // } else if (status == "FAILED") {
    //     statusField.attr("class","text-danger");
    // }
}